package ch.kri.fhbb.WebServer2;

import java.io.*;
import java.net.*;
import java.util.*;

public class WebServer2 extends javax.swing.JFrame {

    Set connections; // set of currently open connections
    Listener serverThread; // the thread we will use for the server
    final int maxConnections = 10;
        
    /** Creates new form WebServer1 */
    public WebServer2() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jScrollPane1 = new javax.swing.JScrollPane();
        txtLog = new javax.swing.JTextArea();
        lblPort = new javax.swing.JLabel();
        txtPort = new javax.swing.JTextField();
        btnGo = new javax.swing.JButton();
        btnStop = new javax.swing.JButton();
        
        getContentPane().setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        jScrollPane1.setPreferredSize(new java.awt.Dimension(400, 300));
        txtLog.setPreferredSize(new java.awt.Dimension(600, 17));
        jScrollPane1.setViewportView(txtLog);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 4;
        gridBagConstraints1.gridheight = 2;
        getContentPane().add(jScrollPane1, gridBagConstraints1);
        
        lblPort.setText("Port");
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        getContentPane().add(lblPort, gridBagConstraints1);
        
        txtPort.setText("80");
        txtPort.setPreferredSize(new java.awt.Dimension(150, 21));
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        getContentPane().add(txtPort, gridBagConstraints1);
        
        btnGo.setText("Go");
        btnGo.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnGoMouseClicked(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        getContentPane().add(btnGo, gridBagConstraints1);
        
        btnStop.setText("Stop");
        btnStop.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnStopMouseClicked(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        getContentPane().add(btnStop, gridBagConstraints1);
        
        pack();
    }//GEN-END:initComponents

    private void btnStopMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnStopMouseClicked
        serverThread.stopListening();
    }//GEN-LAST:event_btnStopMouseClicked

    private void btnGoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnGoMouseClicked
        try {
            connections = new HashSet(maxConnections);
            serverThread = new Listener(Integer.parseInt(txtPort.getText()));
            serverThread.start();
        }
        catch (Exception e) {
            log(e.toString());
        }
    }//GEN-LAST:event_btnGoMouseClicked

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm

    public static void main(String args[]) {
        new WebServer2().show();
    }

    protected synchronized void addConnection(Socket s) {
        if (connections.size() >= maxConnections) {
            try {
                PrintWriter outClient = new PrintWriter(s.getOutputStream());
                outClient.print("Server busy - connection refused\n");
                outClient.flush();
                outClient.close();
                s.close();
                log("ClientConnection:" + s.getInetAddress().getHostAddress() + ":" + s.getPort());
            }
            catch (Exception e) {
                log(e.toString());
            }
        } else {
            ClientConnection c = new ClientConnection(s);
            connections.add(c);
            c.start();
        }
    }
    
    protected void log(String in) {
        String newText = txtLog.getText() + "\n" + in;
        txtLog.setText(newText);
    }
    
    // Thread class that listens for connections. When a request arrives, it creates
    // an independent thread to communicate with the client. This is a cleaner solution
    // than the implicit anonymous class used in WebServer1.
    public class Listener extends Thread {
        ServerSocket listener;
        int port;
        volatile boolean stopThread = false;
        
        public Listener(int port) throws IOException {
            super("Listener:" + port); // name of our thread
            listener = new ServerSocket(port);
            listener.setSoTimeout(0); // never time out
            this.port = port;
        }

        public void stopListening() {
            this.stopThread = true;
            this.interrupt();
            try { listener.close(); }
            catch(IOException e) {}
        }
        
        public void run() {
            log("Starting listener");
            while (!stopThread) {
                try {
                    Socket client = listener.accept(); // wait for a request
                    addConnection(client); // process the request
                }
                catch (InterruptedIOException e) { } // do nothing - this was just a timeout
                catch (IOException e) { log("IOException " + e.toString()); }
            }
            log("Stopped listener");
        }
    }
    
    public class ClientConnection extends Thread {
        Socket client;
        String clientAddress;
        
        public ClientConnection(Socket client) {
            super("ClientConnection:" + client.getInetAddress().getHostAddress() + ":" + client.getPort());
            clientAddress = client.getInetAddress().getHostAddress() + ":" + client.getPort();
            log("ClientConnection:" + clientAddress);
            this.client = client;
        }
        
        public void run() {
            try {
                    // Create input and output streams to talk to the client
                    BufferedReader inClient = new BufferedReader(new InputStreamReader(client.getInputStream()));
                    PrintWriter outClient = new PrintWriter(client.getOutputStream());

                    // Read request from client and parse out the file name from the first line
                    String inString;
                    String strFileName = "xxxx.html";
                    while( (inString = inClient.readLine()) != null) {
                        if (inString.length() == 0) {
                          break; // an empty line is the end of the request
                        } else {
                            if (inString.regionMatches(0, "GET ", 0, 4)) {
                                int fileNameEnd = inString.indexOf(" ", 4);
                                strFileName = "c:" + inString.substring(4, fileNameEnd);
                            }
                        }
                        //outClient.print(inString + "\n");
                    }

                    File fileIn = new File(strFileName);
                    
                    if (!fileIn.exists()) { // 404
                      // Send our reply using HTTP 1.0
                      outClient.print("HTTP/1.0 404 \n"); // Version and status
                      outClient.print("Content-Type: text/plain\n");
                      outClient.print("\n");
                      outClient.println("HTTP 404 - File not found: " + strFileName);
                    } else
                    {
                      BufferedReader inFromFile = null;
                      // Send our reply using HTTP 1.0
                      outClient.print("HTTP/1.0 200 \n"); // Version and status
                      outClient.print("Content-Type: text/html\n");
                      outClient.print("\n");
                      
                      try {
                        inFromFile = new BufferedReader(new InputStreamReader(new FileInputStream(fileIn)));
                            
                        // In einer Schleife: lesen, schreiben - bis wir fertig sind
                        while( (inString = inFromFile.readLine()) != null) {
                          outClient.println(inString);
                        }
                      }
                      catch (Exception e) {
                        log(e.toString());
                      }
                      finally { // Ob Fehler oder nicht, wir mussen die Streams schliessen
                        if (inFromFile != null) try { inFromFile.close(); } catch (IOException e2) { }
                      }
                    }

                    outClient.close();
                    inClient.close();
                    client.close();
            }
            catch (Exception e) {
                log(e.toString());
            }
            finally {
                connections.remove(this);
                log("Connection closed to " + clientAddress);
            }
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea txtLog;
    private javax.swing.JLabel lblPort;
    private javax.swing.JTextField txtPort;
    private javax.swing.JButton btnGo;
    private javax.swing.JButton btnStop;
    // End of variables declaration//GEN-END:variables

}
